#ifndef PLAYER_H
#define PLAYER_H
#include "vs10xx.h"

/** Playing states definations. */
volatile typedef enum {
  PS_STOP,	       // Player stop						 
  PS_PLAY,         // Start to player                                    
  PS_PAUSE,        //Pause play                                         
  PS_RECORDING,    //Recording states                                   
} playerStatetype;

/** Control states definations. */
volatile typedef enum
{
  CS_EMPTY = 0,      // Have no control                                     
  CS_PLAYPAUSE,      // Play/pause button pressed                     
  CS_RECORDING,      // Play/pause button long pressed               
  CS_UP,             // Up button pressed                                                          
  CS_DOWN,           // Down button pressed                                                       
  CS_NEXT,           // Right button pressed                                                      
  CS_PREV,           // Left button pressed                                                       
} ctrlStatetype;

class Player
{
public:
    void begin(void);
    void playFile(char *file);
    void RED();
    void GREEN();
    void BLUE();
    void setup();
    int getGX();
    int getGY();
    int mode();
    void letplay();
    void angry();
    void cry();
    void print_list();
    void select_list();

private:
    
};

#endif
